/*
 * InfoSNES - Super Nintendo (TM) emulator
 * Copyrigh(c) 2003 Jay's Factory (jays_factory@excite.co.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef M65816_H
#define M65816_H

/*-------------------------------------------------------------------*/
/*  Include Files                                                    */
/*-------------------------------------------------------------------*/

#include "type.h"

/*-------------------------------------------------------------------*/
/*  Function Prototype                                               */
/*-------------------------------------------------------------------*/

extern void dumpregs();
extern inline u8 readmem(u8 bank, u16 addr);
extern inline void writemem(u8 bank, u16 addr, u8 val);
extern void updatemode();
extern void badopcode();
extern void int65816();
extern void nmi65816();
extern void exec65816(int cycs);
extern void reset65816();

/*-------------------------------------------------------------------*/
/*  Macros                                                           */
/*-------------------------------------------------------------------*/

#define readfast(b,a)  mempointers[b][a>>15][a&0x7FFF]

/*-------------------------------------------------------------------*/
/*  Type Definitions                                                 */
/*-------------------------------------------------------------------*/

typedef union
{
  u16 w;
  struct
  {
    u8 l,h;
  } b;
} sreg;

/*-------------------------------------------------------------------*/
/*  Global Variables                                                 */
/*-------------------------------------------------------------------*/

extern int instructions;
extern int output;
extern u8 pbr;
extern u16 pc;
extern u8 opcode;
extern u16 d;

extern sreg a,x,y,s;

extern int inint;
extern int cycles,oldcycles;

extern s8 offset;

extern u8 temp, temp2, tempb, al,ah;
extern u16 tempa, tempa2, tempw, tempw2;
extern u32 templ,templ2;
extern int tempi,tempv, hc;
 
#endif /* M65816_H */
