/*
 * InfoSNES - Super Nintendo (TM) emulator
 * Copyrigh(c) 2003 Jay's Factory (jays_factory@excite.co.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*-------------------------------------------------------------------*/
/*  Include Files                                                    */
/*-------------------------------------------------------------------*/

#include <stdio.h>

#include "spu.h"
#include "type.h"

/*-------------------------------------------------------------------*/
/*  DSP Resources                                                    */
/*-------------------------------------------------------------------*/

u8 activechan=0;
u16 pitch[8];

/*-------------------------------------------------------------------*/
/*  Functions                                                        */
/*-------------------------------------------------------------------*/

void updatevoice0()
{
  //  printf("%i %04X %04X\n",activechan&1,pitch[0],getspupc());

  if (!(activechan&1) || !pitch[0])
    return;
  // sound((440*pitch[0])>>12);
}

void writedsp(u8 reg, u8 val)
{
  // printf("%02X %02X %04X\n",reg,val,getspupc());

  switch (reg)
  {
  case 0x02: /*Low pitch*/
    pitch[reg>>4]&=0xFF00;
    pitch[reg>>4]|=val;
    break;
  case 0x03: /*High pitch*/
    pitch[reg>>4]&=0xFF;
    pitch[reg>>4]|=val<<8;
    updatevoice0();
    break;

  case 0x4C: /*Key on*/
    activechan|=val;
    updatevoice0();
    break;
  case 0x5C: /*Key off*/
    activechan&=~val;
    updatevoice0();
    break;
  }
}
