/*
 * InfoSNES - Super Nintendo (TM) emulator
 * Copyrigh(c) 2003 Jay's Factory (jays_factory@excite.co.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef IO_H
#define IO_H

/*-------------------------------------------------------------------*/
/*  Function Prototype                                               */
/*-------------------------------------------------------------------*/

extern unsigned char readio(unsigned short addr);
extern void writeio(unsigned short addr, unsigned char val);

/*-------------------------------------------------------------------*/
/*  Global Variables                                                 */
/*-------------------------------------------------------------------*/

extern int dmaout;

extern int vertcomp;
extern int vblank;
extern int nmienable;
extern int intenable;
extern unsigned char dmactrl[8],dmadest[8];
extern unsigned long dmasrc[8],dmasize[8];
extern unsigned char hdmaon;

#if 0
/*-------------------------------------------------------------------*/
/*  Key Systems                                                      */
/*-------------------------------------------------------------------*/

#define KEY_S     0
#define KEY_A     1
#define KEY_Q     2
#define KEY_W     3
#define KEY_X     4
#define KEY_Z     5
#define KEY_D     6
#define KEY_C     7
#define KEY_UP    8
#define KEY_DOWN  9
#define KEY_LEFT  10
#define KEY_RIGHT 11
#define KEY_END   12 

extern unsigned char key[ KEY_END ];
#endif

#endif /* IO_H */

