#ifndef PPU_H
#define PPU_H

/*-------------------------------------------------------------------*/
/*  Include Files                                                    */
/*-------------------------------------------------------------------*/

#include "type.h"

/*-------------------------------------------------------------------*/
/*  Function Prototype                                               */
/*-------------------------------------------------------------------*/

extern u8 readppu(u16 addr);
extern void writeppu(u16 addr, u8 val);
extern void initvideo();
extern void drawscreen();
extern void swapsprite();
extern void closevideo();
extern void dumpppuregs();
extern void takescreenshot();

/*-------------------------------------------------------------------*/
/*  Macros                                                           */
/*-------------------------------------------------------------------*/

#define getm7pixel(x,y) temp=vram[((y>>3)<<8)|((x>>3)<<1)]; col=vram[(temp<<7)+((y&7)<<4)+((x&7)<<1)+1]

/*-------------------------------------------------------------------*/
/*  Global Variables                                                 */
/*-------------------------------------------------------------------*/

extern int spuskip;
extern int checkf000;
extern int hdmaena;
extern int rotozoom;
extern u8 extbgenable;
extern int palf;

extern int vertcomp;
extern int intenable;

extern u8 *vram;
extern unsigned long vramaddr;

extern int fps,frames;

#endif /* PPU_H */
