/*
 * InfoSNES - Super Nintendo (TM) emulator
 * Copyrigh(c) 2003 Jay's Factory (jays_factory@excite.co.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef SNES_H
#define SNES_H

/*-------------------------------------------------------------------*/
/*  Include Files                                                    */
/*-------------------------------------------------------------------*/

#include "type.h"

/*-------------------------------------------------------------------*/
/*  SNES Resources                                                   */
/*-------------------------------------------------------------------*/

extern u8 ram[0x20000];
extern u8 rom[0xC0][0x8000]; /* 6 megs gone already!!!! */
extern u8 sram[0x10000];

/*-------------------------------------------------------------------*/
/*  Other Resources                                                  */
/*-------------------------------------------------------------------*/

extern int v_line, latchedvline;
extern int vbline;
extern int palf;
extern int frame;

/*-------------------------------------------------------------------*/
/*  Function Prototypes                                              */
/*-------------------------------------------------------------------*/

extern void dumpram();
extern void loadsmc(char *fn);
extern void countsecs();
extern void execsnes(int lines);

#endif /* SNES_H */
